//+------------------------------------------------------------------+
//|                                        ezMM - Close All SELL.mq4 |
//|                              Copyright  2009, MethodTraders.com |
//|                                     http://www.methodtraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MethodTraders.com"
#property link      "http://www.methodtraders.com"
#include <WinUser32.mqh>

int MagicNumber;string    Commentary;
string OT;
int TP;
int SL;
double Lots;
int MyDigits;
double MyPoint;


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----  
  if(Digits==5)MyDigits=4;
  else if(Digits==3)MyDigits=2;
  else MyDigits = Digits; 
  if (Point == 0.00001) MyPoint = 0.0001; //6 digits
  else if (Point == 0.001) MyPoint = 0.01; //3 digits (for Yen based pairs)
  else MyPoint = Point; //Normal
  //---- may be undefined (zero)


     Comment( "ezMM - Close ALL Order  | Closing ALL Orders, please wait ..." );	
     Wait();
      subCloseOrder();
      subCloseOrder();
      subCloseOrder();
  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+

void Wait() { while( IsTradeContextBusy() ) { Sleep(50); } }

int subCloseOrder()
{
   int
         cnt, 
         total       = 0,
         ticket      = 0,
         err         = 0,
         c           = 0;

   total = OrdersTotal();
   int NumberOfTries = 15;
   int Slippage = 5;
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(true==true)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,CLR_NONE);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               break;
               
            case OP_SELL     :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,CLR_NONE);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               break;
               
         }
      }
   }      
   return(ticket);
}

