//+------------------------------------------------------------------+
//|                                                  ezMM - SELL.mq4 |
//|                              Copyright  2009, MethodTraders.com |
//|                                     http://www.methodtraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MethodTraders.com"
#property link      "http://www.methodtraders.com"

int MagicNumber;double Lots;string    Commentary;
int MyDigits;
double MyPoint;


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----  
  if(Digits==5)MyDigits=4;
  else if(Digits==3)MyDigits=2;
  else MyDigits = Digits; 
  if (Point == 0.00001) MyPoint = 0.0001; //6 digits
  else if (Point == 0.001) MyPoint = 0.01; //3 digits (for Yen based pairs)
  else MyPoint = Point; //Normal
//---- A few checks before we get started
   if( !IsConnected()   ) { Alert( " - No Connection!!" );               return(0); }

   if(ObjectFind("ezMM MagicNumber")!=-1&&ObjectFind("ezMM SLots")!=-1&&ObjectFind("ezMM SSL")!=-1&&ObjectFind("ezMM FTP")!=-1)
   {
      MagicNumber = StrToInteger(ObjectDescription("ezMM MagicNumber"));
      int SL = StrToInteger(ObjectDescription("ezMM SSL"));
      int TP = StrToInteger(ObjectDescription("ezMM FTP"));
      double Lots = StrToDouble(ObjectDescription("ezMM SLots"));
      
      Commentary = "ezMM - SELL";
      Comment( Commentary+ " | Placing Short Order, please wait ..." );	
      Wait();
      int ticket = subOpenOrder(OP_SELL, SL, TP, Lots);
      if(ticket>0)Comment("");       
                       
   }
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
void Wait() { while( IsTradeContextBusy() ) { Sleep(50); } }
int subOpenOrder(int type, int stoploss, int takeprofit,double Lotz)
{
   string TicketComment = Commentary;
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;
   int NumberOfTries = 10;
   int Slippage = 5;
   if(stoploss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-stoploss*MyPoint,Digits);
      bStopLoss   = NormalizeDouble(Bid+stoploss*MyPoint,Digits);
   }
   
   if(takeprofit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+takeprofit*MyPoint,Digits);
      bTakeProfit = NormalizeDouble(Bid-takeprofit*MyPoint,Digits);
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_BUY,Lotz,Ask,Slippage,aStopLoss,aTakeProfit,TicketComment,MagicNumber,0,CLR_NONE);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,Lotz,Bid,Slippage,bStopLoss,bTakeProfit,TicketComment,MagicNumber,0,CLR_NONE);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else if( err == 4109 )
            {
               Alert( Commentary + " - You did not allow live trading!" );
               break;
            }
            else if( err==  134 )
            {
                Alert( Commentary + " - Not enough Money!" );              
               break;
            }
         
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }  
   return(ticket);
}

